! -*- F90 -*-
      program Solid_harm
        call header
        call driver
      end program Solid_harm

      subroutine header
        write(6,*) 
        write(6,*) ' the cartesian expansion coefficients '  
        write(6,*) ' of real solid harmonics '
        write(6,*) '   IRP implementation '
        write(6,*) ' '
        write(6,*) ' P. Reinhardt (Paris), 2010 '
        write(6,*) 
      end subroutine header

      subroutine driver
        implicit none
        integer :: ix,iy,iz,m,l,num_tot
        real*8 :: yyy
        
        write(6,*)
        write(6,*) ' real solid harmonics ylm up to ',lmax
        write(6,*)
        
        do l=0,lmax
         do m=-l,l
          write(6,9002) l,m,ylm_name(l,m)
9002      format(' l = ',i3,' m = ',i3,' : ',a5)
          do ix=0,l
           do iy=0,l-ix
            iz=l-ix-iy
            yyy=ylm(l,m,ix,iy)
            if (abs(yyy).gt.1.d-12) write(6,9001) ix,iy,iz,yyy
           end do
          end do
          write(6,*) 
         end do
        end do
9001    format('        coefficient for the term x^',i2,' y^',i2,' z^',i2,' is ',F26.12)
        
      end subroutine driver
